<?php
if ($ms['MODULES']['CACHE_FRONT_END'] and !$ms['MODULES']['CACHE_TIME_OUT_SEARCH_PAGES']) $ms['MODULES']['CACHE_FRONT_END']=0;
if ($ms['MODULES']['CACHE_FRONT_END'])
{
	$options = array(
		'caching' => true,
		'cacheDir' => $this->DOCUMENT_ROOT.'uploads/tx_multishop/tmp/cache/',
		'lifeTime' => $ms['MODULES']['CACHE_TIME_OUT_SEARCH_PAGES']
	);
	$Cache_Lite = new Cache_Lite($options);
	$string=md5('ajax_products_search_'.$this->showCatalogFromPage.'_'.$_REQUEST['q'].'_'.$get['page']);
}
if (!$ms['MODULES']['CACHE_FRONT_END'] or ($ms['MODULES']['CACHE_FRONT_END'] and !$content=$Cache_Lite->get($string)))
{
	$data=array();
	if ($_REQUEST['q'])
	{
		$get['q'] = $_REQUEST['q'];	
		$get['q'] = trim($get['q']);
		$get['q'] = $GLOBALS['TSFE']->csConvObj->utf8_encode($get['q'], $GLOBALS['TSFE']->metaCharset);
		$get['q'] = $GLOBALS['TSFE']->csConvObj->entities_to_utf8($get['q'],TRUE);
		$get['q'] = mslib_fe::RemoveXSS($get['q']);	
	}
//	if ($_REQUEST['q'] and strlen($_REQUEST['q']) < 3) exit();
	
	/**
	 * Perform a simple text replace
	 * This should be used when the string does not contain HTML
	 * (off by default)
	 */
	define('STR_HIGHLIGHT_SIMPLE', 1);
	
	/**
	 * Only match whole words in the string
	 * (off by default)
	 */
	define('STR_HIGHLIGHT_WHOLEWD', 2);
	
	/**
	 * Case sensitive matching
	 * (on by default)
	 */
	define('STR_HIGHLIGHT_CASESENS', 0);
	
	/**
	 * Overwrite links if matched
	 * This should be used when the replacement string is a link
	 * (off by default)
	 */
	define('STR_HIGHLIGHT_STRIPLINKS', 8);
	
	/**
	 * Highlight a string in text without corrupting HTML tags
	 *
	 * @author      Aidan Lister <aidan@php.net>
	 * @version     3.1.0
	 * @param       string          $text           Haystack - The text to search
	 * @param       array|string    $needle         Needle - The string to highlight
	 * @param       bool            $options        Bitwise set of options
	 * @param       array           $highlight      Replacement string
	 * @return      Text with needle highlighted
	 */
	function str_highlight($text, $needle='', $options = null, $highlight = null)
	{
		if (!$needle) return $text;
		// Default highlighting
		if ($highlight === null) {
			$highlight = '<strong class="highlight">\1</strong>';
		}
	
		// Select pattern to use
		if ($options & STR_HIGHLIGHT_SIMPLE) {
			$pattern = '#(%s)#';
		} else {
			$pattern = '#(?!<.*?)(%s)(?![^<>]*?>)#';
			$sl_pattern = '#<a\s(?:.*?)>(%s)</a>#';
		}
	
		// Case sensitivity
	/*
		if ($options ^ STR_HIGHLIGHT_CASESENS) {
	
			$pattern .= 'i';
			$sl_pattern .= 'i';
		}
	*/
			$pattern .= 'i';
			$sl_pattern .= 'i';
	
		$needle = (array) $needle;
		foreach ($needle as $needle_s) {
			$needle_s = preg_quote($needle_s);
	
			// Escape needle with optional whole word check
			if ($options & STR_HIGHLIGHT_WHOLEWD) {
				$needle_s = '\b' . $needle_s . '\b';
			}
	
			// Strip links
			if ($options & STR_HIGHLIGHT_STRIPLINKS) {
				$sl_regex = sprintf($sl_pattern, $needle_s);
				$text = preg_replace($sl_regex, '\1', $text);
			}
	
			$regex = sprintf($pattern, $needle_s);
			$text = preg_replace($regex, $highlight, $text);
		}
	
		return $text;
	}
	$p = !$get['page'] ? 0 : $get['page'];
	if (!is_numeric($p)) $p=0;
	$limit = 4;
	$offset = $p * $limit;
	$modules=array();
	$orders_filter=array();
	$products_filter=array();
	$customers_filter=array();
	if (is_numeric($get['q']))
	{
		// numeric so first find orders and customer ids
		$modules['orders']=1;
		$modules['invoices']=1;
		$modules['customers']=1;
		$modules['products']=1;
		$modules['categories']=1;
		$orders_filter[]='orders_id like "'.addslashes($get['q']).'%"';
		$invoices_filter[]='invoice_id like "'.addslashes($get['q']).'%"';
		$customers_filter[]='customers_id like "'.addslashes($get['q']).'%"';
		$products_filter[]='p.products_id like "'.addslashes($get['q']).'%"';
		$categories_filter[]='c.products_id like "'.addslashes($get['q']).'%"';
	}
	else
	{
		// string
		$modules['products']=1;
		$modules['categories']=1;
		$modules['orders']=1;
		$modules['customers']=1;
		if ($this->ADMIN_USER)
		{
			$modules['admin_cms']=1;
			$modules['admin_settings']=1;
		}		
	}
	// cms search
	if ($modules['admin_cms'])
	{
		$filter		=array();
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >0)
		{
			$items=array();
			$items[] ="cd.name LIKE '%".addslashes($get['q'])."%'";				
//			$items[] ="cd.content LIKE '%".addslashes($get['q'])."%'";				
			$filter[]='('.implode(" or ",$items).')';
		}	
//		if (!$this->masterShop) $filter[]='page_uid='.$this->shop_pid;
		$select[]='cd.id, cd.name';
		$orderby[]='cd.name';
		$pageset=mslib_fe::getCMSPageSet($filter,$offset,$get['limit'],$orderby,$having,$select,$where,$from);		
		$resultset['admin_cms']=$pageset;
	}
	// cms search eof		
	// admin_settings search
	if ($modules['admin_settings'])
	{
		$filter		=array();
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >0)
		{
			$items=array();
			$items[] ="c.configuration_title LIKE '%".addslashes($get['q'])."%'";				
//			$items[] ="c.description LIKE '%".addslashes($get['q'])."%'";				
			$items[] ="c.configuration_key LIKE '%".addslashes($get['q'])."%'";				
			$items[] ="c.configuration_value LIKE '%".addslashes($get['q'])."%'";				
			$items[] ="cv.configuration_value LIKE '%".addslashes($get['q'])."%'";				

			$filter[]='('.implode(" or ",$items).')';
			$filter[] ="(cv.page_uid is NULL or cv.page_uid='".$this->showCatalogFromPage."')";				
		}	
//		if (!$this->masterShop) $filter[]='page_uid='.$this->shop_pid;
		$select[]='c.id, c.configuration_title';
		$orderby[]='c.configuration_title';
		$pageset=mslib_fe::getAdminSettingsPageSet($filter,$offset,$get['limit'],$orderby,$having,$select,$where,$from);		
		$resultset['admin_settings']=$pageset;
	}
	// admin_settings search eof	
	// categories search
	if ($modules['categories'])
	{
		$filter		=$categories_filter;
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >0)
		{
			$items=array();
			$items[] ="cd.categories_name LIKE '%".addslashes($get['q'])."%'";				
			$filter[]='('.implode(" or ",$items).')';
//			$filter[]='(f.disable=0 and f.deleted=0)';
		}	
		if (!$this->masterShop) $filter[]='c.page_uid='.$this->showCatalogFromPage;
		$select[]='c.categories_url, cd.categories_name, c.categories_id';
		$orderby[]='cd.categories_name';
		$pageset=mslib_fe::getCategoriesPageSet($filter,$offset,$get['limit'],$orderby,$having,$select,$where,$from);		
		$resultset['categories']=$pageset;
	}
	// categories search eof		
	// orders search
	if ($modules['orders'])
	{
		$filter		=$orders_filter;
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >0)
		{
			$items=array();
			$items[] ="orders_id='".addslashes($get['q'])."'";
			$items[] ="customer_id LIKE '%".addslashes($get['q'])."%'";				
			$filter[]='('.implode(" or ",$items).')';
//			$filter[]='(f.disable=0 and f.deleted=0)';
		}	
		if (!$this->masterShop) $filter[]='o.page_uid='.$this->showCatalogFromPage;
		$select[]='o.*, os.name as orders_status';
		$orderby[]='o.orders_id desc';
		$pageset=mslib_fe::getOrdersPageSet($filter,$offset,$get['limit'],$orderby,$having,$select,$where,$from);		
		$resultset['orders']=$pageset;
	}
	// orders search eof
	
	// invoices search
	if ($modules['invoices'])
	{
		$filter		=$invoices_filter;
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (!$this->masterShop) $filter[]='page_uid='.$this->showCatalogFromPage;
		$select[]='invoice_id,hash';
		$orderby[]='id desc';
		$pageset=mslib_fe::getInvoicesPageSet($filter,$offset,$get['limit'],$orderby,$having,$select,$where,$from);		
		$resultset['invoices']=$pageset;
	}
	// invoices eof	
	// customer search
	if ($modules['customers'])
	{
		$filter		=$customers_filter;
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >0)
		{
			$items=array();
			$items[]="f.uid like '".addslashes($get['q'])."%'";	
			$items[]="f.company like '".addslashes($get['q'])."%'";	
			$items[]="f.name like '".addslashes($get['q'])."%'";	
			$items[]="f.email like '".addslashes($get['q'])."%'";	
			$items[]="f.username like '".addslashes($get['q'])."%'";					
			$filter[]='('.implode(" or ",$items).')';
			$filter[]='(f.disable=0 and f.deleted=0)';
		}	
		$pageset=mslib_fe::getCustomersPageSet($filter,$offset,0,$orderby,$having,$select,$where);
		$resultset['customers']=$pageset;
	}
	// customer search eof
	// product search
	if ($modules['products'] and $get['q'])
	{
		$filter		=$products_filter;
		$having		=array();
		$match		=array();
		$orderby	=array();
		$where		=array();
		$orderby	=array();
		$select		=array();			
		if (strlen($get['q']) >1)
		{
			$array=explode(" ",$get['q']);
			$total=count($array);
			$oldsearch=0;			
			foreach ($array as $item)
			{
				if (strlen($item) < 2)
				{
					$oldsearch=1;
					break;
				}
			}
			if ($ms['MODULES']['FLAT_DATABASE']) 	$tbl='';
			else									$tbl='pd.';
			if ($oldsearch)
			{
				// do normal indexed search	
				$filter[]="(".$tbl."products_name like '".addslashes($get['q'])."%')";					
			}
			else
			{
				// do fulltext search
				$tmpstr=addslashes(mslib_befe::ms_implode(', ', $array,'"','+',true));				
				$select[]	="MATCH (".$tbl."products_name) AGAINST ('".$tmpstr."' in boolean mode) AS score";
				$where[]	="MATCH (".$tbl."products_name) AGAINST ('".$tmpstr."' in boolean mode)";
				$key = 	$get['q'];	
				$orderby[]	='score desc';
			}
		}	
		if (is_numeric($parent_id) and $parent_id > 0)
		{
			if ($ms['MODULES']['FLAT_DATABASE'])
			{
				$string='(';
				for ($i=0;$i<4;$i++)
				{
					if ($i>0) $string.=" or ";
					$string.="categories_id_".$i." = '".$parent_id."'";
				}
				$string.=')';
				if ($string) $filter[]=$string;
				// 
			}
			else
			{
				$cats=mslib_fe::get_subcategory_ids($parent_id);
				$cats[]=$parent_id;
				$filter[]="p2c.categories_id IN (".implode(",",$cats).")";
			}
		}
		$pageset=mslib_fe::getProductsPageSet($filter,$offset,$limit,$orderby,$having,$select,$where,0,array(),array(),'admin_ajax_products_search');
		$resultset['products']=$pageset;
	}
	// product search eof
	// now build up the listing
	// admin cms
	if (count($resultset['admin_cms']['admin_cms']))
	{
		$prod = array();
		$prod['Name'] = "CMS";
		$prod['Title'] = '<span class="admin_ajax_res_header">Admin CMS</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;	
		foreach ($resultset['admin_cms']['admin_cms'] as $category)
		{				
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			$prod['Name'] 	= substr($category['name'],0,50);
			$prod['Title']  = $prod['Name'];
			$prod['Link'] 	= mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&cmt_id='.$category['id']).'&action=edit_cms';
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;	
            $prod['EditIcons']='';			
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['admin_cms']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;		
	}	
	// end admin cms
	// admin settings
	if (count($resultset['admin_settings']['admin_settings']))
	{
		$prod = array();
		$prod['Name'] = "Admin Settings";
		$prod['Title'] = '<span class="admin_ajax_res_header">Admin Settings</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;	
		foreach ($resultset['admin_settings']['admin_settings'] as $category)
		{				
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			$prod['Name'] 	= substr($category['configuration_title'],0,50);
			$prod['Title']  = $prod['Name'];
			$prod['Link'] 	= mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&module_id='.$category['id']).'&action=edit_module';
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;
            $prod['EditIcons']='';				
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['admin_settings']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;		
	}	
	// end admin settings
	// categories
	if (count($resultset['categories']['categories']))
	{
		$prod = array();
		$prod['Name'] = "Categories";
		$prod['Title'] = '<span class="admin_ajax_res_header">Categories</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;	
		foreach ($resultset['categories']['categories'] as $category)
		{				
		  
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			$prod['Name'] 	= substr($category['categories_name'],0,50);
			$prod['Title']  = $prod['Name'];		
			$prod['Link'] 	= mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&cid='.$category['categories_id'].'&action=edit_category');
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;
			if ($category['categories_url'])
			{
				$target=' target="_blank"';
				$link=$category['categories_url'];
			}
			else
			{
				$target="";
				// get all cats to generate multilevel fake url
				$level=0;
				$cats=mslib_fe::Crumbar($get['categories_id']);
				$cats=array_reverse($cats);
				$where='';
				if (count($cats) > 0)
				{
					foreach ($cats as $item)
					{
						$where.="categories_id[".$level."]=".$item['id']."&";
						$level++;
					}
					$where=substr($where,0,(strlen($where)-1));
					$where.='&';
				}
				$where.='categories_id['.$level.']='.$category['categories_id'];
				// get all cats to generate multilevel fake url eof				
				$link=$this->FULL_HTTP_URL.mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
			}
/*			
            $prod['EditIcons']='<ul class="ui-edit-item"><li><a href="'.$link.'" class="ui-edit-view" target="_blank">view</a></li>
<li><a href="'.mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&cid='.$category['categories_id'].'&action=delete_category').'" class="ui-edit-delete" onclick="return hs.htmlExpand(this, { objectType: \'iframe\', width: 910, height: 140} )">delete</a></li></ul>';
*/
			$data[] = $prod;
		}	
        
       
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['categories']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;		
	}	
	// end categories
	// orders
	if (count($resultset['orders']['orders']))
	{
		$prod = array();
		$prod['Name'] = "Orders";
		$prod['Title'] = '<span id="admin_ajax_res_header">Orders</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;	
		foreach ($resultset['orders']['orders'] as $order)
		{				
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			$prod['Name'] 	= substr($order['orders_id'],0,50);
			$prod['Title']  = $prod['Name'];
			$prod['Link'] 	= mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&orders_id='.$order['orders_id']).'&action=edit_order';
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;
            $prod['EditIcons']='';								
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['orders']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;		
		$data[] = $prod;		
	}	
	// end orders
	// invoices
	if (count($resultset['invoices']['invoices']))
	{
		$prod = array();
		$prod['Name'] = "Invoices";
		$prod['Title'] = '<span id="admin_ajax_res_header">Invoices</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;	
		foreach ($resultset['invoices']['invoices'] as $invoice)
		{				
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			$prod['Name'] 	= substr($invoice['invoice_id'],0,50);
			$prod['Title']  = $prod['Name'];
			$prod['Link'] 	= mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=download_invoice&tx_multishop_pi1[hash]='.$invoice['hash']);
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;
            $prod['EditIcons']='';								
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['orders']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;		
		$data[] = $prod;		
	}	
	// end invoices	
	// customers
	if (count($resultset['customers']['customers']))
	{
		$prod = array();
		$prod['Name'] = "Customers";
		$prod['Title'] = '<span id="admin_ajax_res_header">Customers</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;			
		foreach ($resultset['customers']['customers'] as $customer)
		{
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';		
			if (!$customer['company']) 			$customer['company']='N/A';
			if (!$customer['name'])				$customer['name']=$customer['username'];				
			$prod['Name'] 	= substr($customer['name'],0,50);
			$prod['Title']  = $prod['Name'];
			$prod['Link'] = mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=admin_ajax&tx_multishop_pi1[cid]='.$customer['uid'].'&action=edit_customer');
			$prod['Image'] = '';
			$prod['Desc']  = '';				
			$prod['Price'] = '';
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$prod['SmallListing'] = true;
            $prod['EditIcons']='';				
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['customers']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;		
	}	
	// end customers		
	// products
	if (count($resultset['products']['products']))
	{
		$prod = array();
		$prod['Name'] = "Products";
		$prod['Title'] = '<span id="admin_ajax_res_header">Products</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;			
		foreach ($resultset['products']['products'] as $product)
		{
			if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
			else								$tr_type='even';
			$prod['Link'] = mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&cid='.$product['categories_id'].'&pid='.$product['products_id'].'&action=edit_product');
			if ($product['products_image'])
			{
				$prod['Image'] = '<div class="ajax_products_image">'. '<img src="'. mslib_befe::getImagePath($product['products_image'],'products','50')  .'">' . '</div>';
			}
			else
			{
				$prod['Image'] = '<div class="ajax_products_image"><div class="no_image_50"></div>
				</div>';
			}				
			$prod['Title'] = '<div class="ajax_products_name">'. substr($product['products_name'],0,50) .'</div>' ;
			$prod['Title']  = $prod['Title'];
			$prod['Desc']  = '<div class="ajax_products_shortdescription">'. str_highlight(substr($product['products_shortdescription'],0,75),$get['q']) .'</div>';				
			if ($product['products_price'] <> $product['final_price'])
			{
				$prod['Price'] = '<div class="ajax_old_price">'.mslib_fe::Money2Cents($product['products_price'],0).'</div><div class="ajax_specials_price">'.mslib_fe::Money2Cents($product['final_price'],0).'</div>';
			}
			else
			{
				$prod['Price'] = '<div class="ajax_products_price">'.mslib_fe::Money2Cents($product['products_price'],0).'</div>';
			}
			$prod['Name'] = substr($product['products_name'],0,50);
			$prod['skeyword'] = $get['q'];
			$prod['Page'] = $pages;
			$prod['Product'] = true;
			$where='';
			if ($product['categories_id'])
			{
				// get all cats to generate multilevel fake url
				$level=0;
				$cats=mslib_fe::Crumbar($product['categories_id']);
				$cats=array_reverse($cats);
				$where='';
				if (count($cats) > 0)
				{
					foreach ($cats as $cat)
					{
						$where.="categories_id[".$level."]=".$cat['id']."&";
						$level++;
					}
					$where=substr($where,0,(strlen($where)-1));
					$where.='&';
				}
				// get all cats to generate multilevel fake url eof
			}
			if ($product['products_url'] and $ms['MODULES']['AFFILIATE_SHOP']) 		$link=$product['products_url'];
			else $link=$this->FULL_HTTP_URL.mslib_fe::typolink($this->shop_pid,'&'.$where.'&products_id='.$product['products_id']);			
/*			
		   $prod['EditIcons']='<ul class="ui-edit-item"><li><a href="'.$link.'" class="ui-edit-view no_highslide_link">view</a></li><li><a href="'.mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=admin_ajax&cid='.$product['categories_id'].'&pid='.$product['products_id'].'&action=delete_product').'" class="ui-edit-delete" onclick="return hs.htmlExpand(this, { objectType: \'iframe\', width: 910, height: 140} )">delete</a></li></ul>';
*/		   
			
			$data[] = $prod;
		}	
		$prod = array();
		$prod['Name'] = "Total";
		$prod['Title'] = '<span id="admin_ajax_res_footer">Total number: '.$resultset['products']['total_rows'].'</span>';
		$prod['Link'] = false;
		$prod['skeyword'] = $get['q'];
		$prod['Page'] = '';
		$prod['Product'] = false;
		$data[] = $prod;			
	}	
	// end products		
	$content = array("products"=>$data);
	$content=json_encode($content);
	// now build up the listing eof
}
echo $content;
exit;
?>