<?php
$key='MANUFACTURER_IMAGE_SIZE_NORMAL';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
	$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Manufacturer image size', '".$key."', '176x140', 'The maximum image size in pixels for the manufacturer image folder.', 2, NULL, NULL, now(), NULL, '');";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	$messages[]=$str;
}

// ATTRIBUTES STOCK
$key='PRODUCT_ATTRIBUTES_STOCK';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
	$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Attributes Stock', '".$key."', '0', 'Product stock based on attributes option pairing', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'', ''1''),');";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	$messages[]=$str;

	$str="select group_id from tx_multishop_products_attributes_stock_group limit 1";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	if (!$qry)
	{
		$str="CREATE TABLE IF NOT EXISTS `tx_multishop_products_attributes_stock_group` (
					  `group_id` int(11) NOT NULL auto_increment,
					  `products_id` int(11) NOT NULL,
					  `attributes_stock` int(11) NOT NULL,
					  `not_allowed` tinyint(1) NOT NULL default '0',
					  PRIMARY KEY  (`group_id`),
					  KEY `products_id` (`products_id`,`attributes_stock`)
					) ENGINE=MyISAM;";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$messages[]=$str;
	}

	$str="select group_id from tx_multishop_products_attributes_stock limit 1";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	if (!$qry)
	{
		$str="CREATE TABLE IF NOT EXISTS `tx_multishop_products_attributes_stock` (
					  `group_id` int(11) NOT NULL,
					  `options_id` int(11) NOT NULL default '0',
					  `options_values_id` int(11) NOT NULL default '0',
					  KEY `options_id` (`options_id`,`options_values_id`),
					  KEY `group_id` (`group_id`)
					) ENGINE=MyISAM;";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$messages[]=$str;
	}

} else { // just incase the table tx_multishop_products_attributes_stock_group already exists and not yet have the not_allowed field
	$str="select not_allowed from tx_multishop_products_attributes_stock_group limit 1";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	if (!$qry)
	{
		$str="ALTER TABLE  `tx_multishop_products_attributes_stock_group` ADD `not_allowed` tinyint(1) NOT NULL default '0'";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$messages[]=$str;
	}
}

$key='PRODUCT_ATTRIBUTES_STOCK_FRONT_TABLE_VIEW';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
	$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Attributes Stock front view', '".$key."', '0', 'Table view for attributes stock in front product details', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'', ''1''),');";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	$messages[]=$str;
}

// attributes stock eof


$str="select id from tx_multishop_notification limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry) {
	$str="CREATE TABLE `tx_multishop_notification` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `title` varchar(150),
			  `message` text,
			  `customer_id` int(11) NOT NULL default '0',
			  `unread` tinyint(1) NOT NULL default '0',
			  `message_type` varchar(35),
			  `crdate` int(11) NOT NULL default '0',
			  PRIMARY KEY (`id`),
			  INDEX ( `unread` ),
			  INDEX ( `customer_id` ),			  
			  INDEX ( `message_type` )			  
		   ) ENGINE=MyISAM";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	$messages[]=$str;
}

/*
 * Jira ref: MULTISHOP-256
 */
$str="select id from tx_multishop_cart_contents limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry) {
	$str="CREATE TABLE `tx_multishop_cart_contents` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `contents` text,
			  `customer_id` int(11) NOT NULL default '0',
			  `is_checkout` tinyint(1) NOT NULL default '0',
			  `crdate` int(11) NOT NULL default '0',
			  `session_id` varchar(150) NOT NULL DEFAULT '',
			  `ip_address` varchar(150) NOT NULL DEFAULT '',
			  PRIMARY KEY (`id`),
			  INDEX ( `customer_id` )
		   ) ENGINE=MyISAM";
	$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
	$messages[]=$str;
}
/*
 * Jira ref: MULTISHOP-256 EOL
 */

$str="select id from tx_multishop_products_search_log limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry) {
    $str="CREATE TABLE `tx_multishop_products_search_log` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `keyword` varchar(150) NOT NULL,
			  `ip_address` varchar(150) NOT NULL,
			  `crdate` int(11) NOT NULL default '0',
			  `customer_id` int(11) NOT NULL default '0',
			  `negative_results` tinyint(1) NOT NULL DEFAULT '0',
			  PRIMARY KEY (`id`),
			  INDEX ( `keyword` ),
			  INDEX ( `customer_id` ),
			  INDEX ( `negative_results` )
		   ) ENGINE=MyISAM"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select customer_id from tx_multishop_products_search_log limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry) {
    $str="ALTER TABLE  `tx_multishop_products_search_log` ADD  `customer_id` int(11) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
    $str="ALTER TABLE  `tx_multishop_products_search_log` ADD  INDEX ( `customer_id` )"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
}
$str="select orders_products_id from tx_multishop_orders_products_downloads limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="CREATE TABLE  `tx_multishop_orders_products_downloads` (
`orders_products_id` INT( 11 ) NOT NULL ,
`orders_id`	 INT( 11 ) NOT NULL ,
`ip_address` VARCHAR( 255 ) NOT NULL ,
`date_of_download` INT( 11 ) NOT NULL ,
PRIMARY KEY (  `orders_products_id` ) ,
INDEX (  `date_of_download` ),
INDEX (  `orders_id` )
) ENGINE=MyISAM;"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}


$str="select file_remote_location from tx_multishop_orders_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD  `file_remote_location` TEXT NOT NULL"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select file_number_of_downloads from tx_multishop_orders_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD  `file_number_of_downloads` INT( 11 ) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}

$str="select file_remote_location from tx_multishop_products_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD  `file_remote_location` TEXT NOT NULL"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select file_number_of_downloads from tx_multishop_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products` ADD  `file_number_of_downloads` INT( 11 ) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$key='ADMIN_PRODUCTS_SEARCH_AND_EDIT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Products Search and Edit', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin products search and edit page. Example value: fileadmin/scripts/admin_products_search_and_edit', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}	
$key='ULTRASEARCH_SERVER_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Ultrasearch Server Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the ultrasearch server (that generates the ajax products listing). Example value: fileadmin/scripts/ultrasearch_server', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}

$str="select configuration_key from tx_multishop_configuration where configuration_key='DISABLE_WARNING_SYSTEM'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
{
    $str="UPDATE `tx_multishop_configuration` SET `configuration_key` ='DISABLE_MULTISHOP_CONFIGURATION_VALIDATION' WHERE configuration_key='DISABLE_WARNING_SYSTEM';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
	$messages[]=$str;	
}
else
{
	$key='DISABLE_MULTISHOP_CONFIGURATION_VALIDATION';
	if (!isset($settings['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Disable validation of Multishop configuration', '".$key."', '0', 'This setting will disable the validation of the Multishop configuration.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
		$messages[]=$str;
	}
}
$key='REDIRECT_BACK_TO_PRODUCTS_DETAIL_PAGE_AFTER_ADD_TO_CART';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Add to Cart - Redirect Back to Products Detail Page', '".$key."', '0', 'When this module is enabled the user will be redirected back to the products detail page, after adding the product to the cart.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ENABLED_LANGUAGES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Enabled languages', '".$key."', '', 'Optional field (leave empty to enable all TYPO3 enabled languages). Enable only specific languages. Example value: nl,de,es', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='NUMBER_OF_PRODUCT_IMAGES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Number of Product Images', '".$key."', '5', 'Define how many product images you want to use. Default value: 5', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}

$key='ENABLED_CURRENCIES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Enabled Currencies', '".$key."', '', 'Optional field (leave empty to use the default). Use this to display the currencies in the multi currency selector dropdownmenu. Example value: USD,EUR,GBP', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='DEFAULT_CURRENCY';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Default Currency', '".$key."', '', 'Optional field (leave empty to use the default). Use this to select the default currency in the multi currency selector. Example value: USD', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$str="select store_currency from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_invoices` ADD `store_currency` char(3) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select customer_currency from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_invoices` ADD `customer_currency` char(3) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select currency_rate from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_invoices` ADD `currency_rate` varchar(15) NOT NULL default '1'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select store_currency from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `store_currency` char(3) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select customer_currency from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `customer_currency` char(3) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select currency_rate from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `currency_rate` varchar(15) NOT NULL default '1'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$key='ADMIN_MANUFACTURERS_EDIT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Manufacturers Edit Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the manufacturers products listing page. Example value: fileadmin/scripts/admin_manufacturers_edit', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='MANUFACTURERS_PRODUCTS_LISTING_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Manufacturers Products Listing Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the manufacturers products listing page. Example value: fileadmin/scripts/manufacturers_products_listing', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='OLD_PRODUCTS_SEARCH_MODE';	
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Old products search mode', '".$key."', '0', 'Search the catalog without FULL TEXT search.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

$key='ORDER_HISTORY_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Account Order History', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the accounts order history page. Example value: fileadmin/scripts/order_history', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ADMIN_CUSTOMERS_IMPORT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Customers Import Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the customers import module. Example value: fileadmin/scripts/admin_customers_import', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='SPECIALS_SECTION_LISTING_TYPE';
$title='Specials Section Listing Type';
$description='The lay-out type for displaying the listing of the specials (based on section)';
$default_value='default';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 6, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}
$key='DISABLE_PRODUCT_WHEN_NEGATIVE_STOCK';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Disable Product When Negative Stock', '".$key."', '0', 'Automatically turn off the product when the stock level gets negatave.', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'', ''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ADMIN_ORDERS_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Orders Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin orders listing page. Example value: fileadmin/scripts/admin_orders)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='LOCK_ORDER_AFTER_CREATING_INVOICE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Lock Order After Creating Invoice', '".$key."', '1', 'When this setting is enabled the order will be locked after creating the invoice.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'', ''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$str="select track_and_trace_code from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `track_and_trace_code` varchar(50) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select expected_delivery_date from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `expected_delivery_date` int(11) NOT NULL default '0', ADD KEY expected_delivery_date (expected_delivery_date)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select address_ext from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD `address_ext` varchar(10) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select address_ext from tt_address limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tt_address` ADD `address_ext` varchar(10) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select billing_address_ext from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `billing_address_ext` varchar(10) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select delivery_address_ext from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `delivery_address_ext` varchar(10) NOT NULL default ''"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select tx_multishop_source_id from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD `tx_multishop_source_id` varchar(50) NOT NULL default '', ADD KEY tx_multishop_source_id (tx_multishop_source_id)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select hash from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `hash` varchar(50) NOT NULL default '0', ADD KEY hash (hash)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select hash from tx_multishop_cms limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_cms` ADD `hash` varchar(50) NOT NULL default '', ADD KEY hash (hash)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
    $query="select id from tx_multishop_cms where hash=''";
    $res = $GLOBALS['TYPO3_DB']->sql_query($query);
    if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
    {
        while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
        {
            $query2 = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_cms', 'id=\''.$row['id'].'\'',array('hash'=>md5(uniqid('',TRUE))));
            $res2 = $GLOBALS['TYPO3_DB']->sql_query($query2);												
        }	
    }					
}
$str="select products_options_id from tx_multishop_orders_products_attributes limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD `products_options_id` int(11) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;						
}
$str="select products_options_values_id from tx_multishop_orders_products_attributes limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD `products_options_values_id` int(11) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select sort_orders from tx_multishop_products_options_values";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{
    $str="ALTER TABLE  `tx_multishop_products_options_values` DROP  `sort_orders`"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select qty_delivered from tx_multishop_orders_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD `qty_delivered` int(4) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select qty_not_deliverable from tx_multishop_orders_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE `tx_multishop_orders_products` ADD `qty_not_deliverable` int(4) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select cruser_id from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `cruser_id` int(11) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select products_extra_description from tx_multishop_products_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{
    $str="ALTER TABLE  `tx_multishop_products_description` DROP  `products_extra_description`"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
    $str="ALTER TABLE  `tx_multishop_products_description` DROP  `products_extra_tab_description1`"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
    $str="ALTER TABLE  `tx_multishop_products_description` DROP  `products_extra_tab_description2`"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}	
$str="describe `tx_multishop_products`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='staffel_price')
    {
        if ($row['Type']=='varchar(127)')
        {
            $str="ALTER TABLE  `tx_multishop_products` CHANGE  `staffel_price`  `staffel_price` varchar( 250 ) NOT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
            $str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `staffel_price`  `staffel_price` varchar( 250 ) NOT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}
$str="select required from tx_multishop_products_options limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products_options` ADD `required` tinyint(1) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}			
$str="select page_uid from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD `page_uid` int(11) NOT NULL default '0', ADD KEY page_uid (page_uid)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}			
$str="select is_proposal from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD `is_proposal` tinyint(1) NOT NULL default '0', ADD KEY is_proposal (is_proposal)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}				
$key='ADMIN_ORDER_PROPOSAL_MODULE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Order Proposal System', '".$key."', '0', 'Enable the order proposal system.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'',''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ADMIN_INVOICE_MODULE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Invoice System', '".$key."', '0', 'Enable the invoice system.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'',''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='CART_PAGE_UID';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cart session page uid', '".$key."', '', 'Normally the cart of your customer is shared with all shop in shops you create. By giving this setting a custom number the cart is only used on the current shop.', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='PRODUCTS_LISTING_SORT_ORDER_OPTION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Sort-Order Option', '".$key."', 'asc', 'Normally the products in the products listing page gets sorted ascending. By this setting you can switch it to descending.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''asc'',''desc''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='PRODUCTS_NEW_NUMBER_OF_DAYS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products New: number of days', '".$key."', '30', 'The number of days that a product should be listed on the latest products page.', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='MANUFACTURERS_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Manufacturers Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the manufacturers listing page. Example value: fileadmin/scripts/manufacturers_listing', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}

$default_value=0;
$key='INCLUDE_VAT_OVER_METHOD_COSTS';
if (isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="select * from tx_multishop_configuration where configuration_key='".$key."'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);				
    if ($row['set_function']=='tep_cfg_select_option(array(\'1\',\'0\'),')
    {				
        // if its boolean delete it and recreate it
        if ($row['configuration_value'])
        {
            $default_value='19';
        }
        else
        {
            $default_value=0;
        }
        $qry = $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_configuration','configuration_key=\''.$key.'\'');									
        $qry = $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_configuration_values','configuration_key=\''.$key.'\'');									
        unset($settings['GLOBAL_MODULES'][$key]);
    }
}			
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Include VAT percentage over method costs', '".$key."', '".$default_value."', 'When higher than zero the number represents the percentage of VAT that must be counted over the shipping/payment method costs.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='GEONAMES_USERNAME';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Geonames username', '".$key."', '', 'Geonames username. You can register your username here: http://www.geonames.org/.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			

$key='SEARCH_ALSO_IN_PRODUCTS_ID';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Search also in products id', '".$key."', '0', 'This enables the search-engine to also search for the products id.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
if (isset($settings['GLOBAL_MODULES']['INVOICE_PREFIX']) and $settings['GLOBAL_MODULES']['INVOICE_PREFIX']=='0')
{
    // zero is an invalid prefix. lets remove it
    $query2 = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_configuration', 'configuration_key=\'INVOICE_PREFIX\'',array('configuration_value'=>''));
    $res2 = $GLOBALS['TYPO3_DB']->sql_query($query2);				
}		
$str="select reversal_invoice from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_invoices` ADD  `reversal_invoice` tinyint(1) NOT NULL default '0', ADD KEY reversal_invoice (reversal_invoice), ADD   reversal_related_id int(11) NOT NULL default '0', ADD KEY reversal_related_id (reversal_related_id)"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}			
$str="select is_locked from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `is_locked` tinyint(1) NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}			
// rebuild all invoices
/*			
$query="select orders_id from tx_multishop_orders where payed=1 order by orders_id asc";
$res = $GLOBALS['TYPO3_DB']->sql_query($query);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
{
    while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
    {
        $tmp=mslib_fe::createOrderInvoice($row['orders_id']);					
    }	
}			
*/			
// rebuild all invoices eof		
$str="describe `tx_multishop_products_description`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_url')
    {
        if ($row['Type']=='varchar(255)')
        {
            $str="ALTER TABLE  `tx_multishop_products_description` CHANGE  `products_url`  `products_url` TEXT";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}	
$str="describe `tx_multishop_categories`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='categories_url')
    {
        if ($row['Type']=='varchar(254)')
        {
            $str="ALTER TABLE  `tx_multishop_categories` CHANGE  `categories_url`  `categories_url` TEXT";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}	

$str="describe `tx_multishop_shipping_methods`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='provider')
    {
        if ($row['Type']=='varchar(25)')
        {
            $str="ALTER TABLE  `tx_multishop_shipping_methods` CHANGE  `provider`  `provider` varchar( 50 ) NOT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}
$str="describe `tx_multishop_payment_methods`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='provider')
    {
        if ($row['Type']=='varchar(25)')
        {
            $str="ALTER TABLE  `tx_multishop_payment_methods` CHANGE  `provider`  `provider` varchar( 50 ) NOT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}
$key='DISABLE_CRUMBAR';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Disable crumbar navigation menu', '".$key."', '0', 'Disable internal crumbar navigation menu.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'',''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;
}				
$key='INCLUDE_PRODUCTS_DESCRIPTION_DB_FIELD_IN_PRODUCTS_LISTING';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Include products description database field', '".$key."', '0', 'Include products description database field in the products listing page.', 6, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'',''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;
}	
$key='DISABLE_VAT_RATE_WHEN_CROSS_BORDERS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Disable VAT rate when cross borders', '".$key."', '1', 'When a customer is from a different country than the store owner calculate zero tax.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''0'',''1''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;
}			
$key='PRODUCTS_DETAIL_NUMBER_OF_TABS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Detail Tabs', '".$key."', '0', 'Optional field. Number of tabs used on the products detail page.', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='PRODUCTS_DETAIL_NUMBER_OF_TABS';
if (isset($settings['GLOBAL_MODULES'][$key]))
{
    // check if the description table has enough tabs fields
    $total=$settings['GLOBAL_MODULES']['PRODUCTS_DETAIL_NUMBER_OF_TABS'];
    if ($total)
    {
        for ($i=1;$i<=$total;$i++)
        {
            $name='products_description_tab_content_'.$i;	
            $str="select ".$name." from tx_multishop_products_description limit 1";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            if (!$qry)
            {
                $str="ALTER TABLE  `tx_multishop_products_description` ADD  `products_description_tab_content_".$i."` TEXT NULL"; 
                $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
                $messages[]=$str;				
                $str="ALTER TABLE  `tx_multishop_products_description` ADD  `products_description_tab_title_".$i."` varchar(50) NULL"; 
                $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
                $messages[]=$str;				
            }					
        }
    }
}
$key='NUMBER_OF_PRODUCT_IMAGES';
if (isset($settings['GLOBAL_MODULES'][$key]))
{
    // check if the products table has enough product image fields
	for ($x=0;$x<=($settings['GLOBAL_MODULES']['NUMBER_OF_PRODUCT_IMAGES']-1);$x++)
	{
		$i=$x;
		if ($i==0) $i='';	
		$field='products_image'.$i;			
		$str="select ".$field." from tx_multishop_products limit 1";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if (!$qry)
		{
			$str="ALTER TABLE  `tx_multishop_products` ADD `products_image".$i."` varchar(50) NULL"; 
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			$messages[]=$str;			
		}					
	}
}
$query = $GLOBALS['TYPO3_DB']->SELECTquery(
                'id',         // SELECT ...
                'tx_multishop_invoices',     // FROM ...
                'hash=\'\'',    // WHERE...
                '',            // GROUP BY...
                '',    // ORDER BY...
                ''            // LIMIT ...
);
$res = $GLOBALS['TYPO3_DB']->sql_query($query);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
{
    while(($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) != false)
    {
        $query2 = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_invoices', 'id=\''.$row['id'].'\'',array('hash'=>md5(uniqid('',TRUE))));
        $res2 = $GLOBALS['TYPO3_DB']->sql_query($query2);
    }	
}
$query = $GLOBALS['TYPO3_DB']->SELECTquery(
                'uid',         // SELECT ...
                'fe_users',     // FROM ...
                'tx_multishop_code=\'\'',    // WHERE...
                '',            // GROUP BY...
                '',    // ORDER BY...
                ''            // LIMIT ...
);
$res = $GLOBALS['TYPO3_DB']->sql_query($query);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
{
    while(($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) != false)
    {
        $query2 = $GLOBALS['TYPO3_DB']->UPDATEquery('fe_users', 'uid=\''.$row['uid'].'\'',array('tx_multishop_code'=>md5(uniqid('',TRUE))));
        $res2 = $GLOBALS['TYPO3_DB']->sql_query($query2);
    }	
}		

$key='ADMIN_CUSTOMERS_EDIT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Customers Edit Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the edit customer form. Example value: fileadmin/scripts/admin_edit_customer', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}

$key='ADMIN_PRODUCTS_IMPORT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Products Import Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the products import module. Example value: fileadmin/scripts/admin_import', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='DOWNLOAD_INVOICE_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Download Invoice Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the PDF invoice. Example value: fileadmin/scripts/download_invoice', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='CATEGORIES_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Categories Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the categories navigation box content element. Example value: fileadmin/scripts/categories_nav', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='CRUMBAR_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Crumbar Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the crumbar. Example value: fileadmin/scripts/crumbar', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='BASKET_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Basket Content Element Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the cart contents element. Example value: fileadmin/scripts/basket_content_element', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='CREATE_ACCOUNT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Create Account Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the create account page. Example value: fileadmin/scripts/create_account', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='EDIT_ACCOUNT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Edit Account Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the edit account page. Example value: fileadmin/scripts/edit_account', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			

$key='INVOICE_PDF_HEADER_IMAGE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(12, 'Invoice Settings', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
    $messages[]=$str;				
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Invoice PDF header image', '".$key."', '', 'Full URL to header image of the PDF invoice.', 12, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
    $key='INVOICE_PDF_FOOTER_IMAGE';
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Invoice PDF footer image', '".$key."', '', 'Full URL to footer image of the PDF invoice.', 12, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;				
}			
$key='MULTISHOP_VERSION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Multishop version', '".$key."', '0', 'Database version.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='SUBTRACT_STOCK';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Subtract Stock', '".$key."', '0', 'Enable the subtraction of the products stock level.', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$str="select tx_multishop_code from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD  `tx_multishop_code` varchar( 50 ) NOT NULL ,ADD INDEX (  `tx_multishop_code` )"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select tx_multishop_optin_ip from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD  `tx_multishop_optin_ip` varchar( 50 ) NOT NULL"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select tx_multishop_optin_crdate from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD  `tx_multishop_optin_crdate` int(10) unsigned NOT NULL default '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select tx_multishop_newsletter from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `fe_users` ADD  `tx_multishop_newsletter` tinyint( 1 ) NOT NULL DEFAULT  '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select address_number from tt_address limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tt_address` ADD  `address_number` varchar( 10 ) NOT NULL"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}

$str="select tx_multishop_customer_id from tt_address limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tt_address` ADD  `tx_multishop_customer_id` INT( 11 ) NOT NULL ,
ADD INDEX (  `tx_multishop_customer_id` )"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}
$str="select tx_multishop_default from tt_address limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tt_address` ADD  `tx_multishop_default` tinyint( 1 ) NOT NULL ,
ADD INDEX (  `tx_multishop_default` )"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}


$str="select products_condition from tx_multishop_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products` ADD products_condition varchar(20) NOT NULL DEFAULT 'new'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}	
$str="select include_header from tx_multishop_product_feeds limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_product_feeds` ADD include_header tinyint(1) NOT NULL DEFAULT '0'"; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}	

$str="select customer_id from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_invoices` ADD customer_id int(11) NOT NULL,ADD crdate int(11) DEFAULT '0',
    ADD due_date int(11) NOT NULL,
    ADD reference varchar(150) NOT NULL,
    ADD ordered_by varchar(50) NOT NULL,
    ADD invoice_to varchar(50) NOT NULL,
    ADD payment_condition varchar(50) NOT NULL,
    ADD currency varchar(5) NOT NULL,
    ADD discount double(10,4) NOT NULL,
    ADD amount double(10,4) NOT NULL,
    ADD page_uid int(11) NOT NULL,
    ADD payed tinyint(1) NOT NULL,
    ADD `hash` varchar(50) NOT NULL,
    ADD KEY payed (payed),
    ADD KEY `hash` (`hash`),
    ADD KEY customer_id (customer_id)
    "; 
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}					
$str="select count(1) as total from tx_multishop_products_description where language_id=0";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
if (!$row['total'])
{
    $str="select count(1) as total from tx_multishop_products_description";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
    if ($row['total'])
    {	
        // there are products in the database, but they are not saved as default language id 0, so lets correct this
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_categories_description', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_description', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_manufacturers_cms', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_manufacturers_info', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);			
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options_values', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options_values_extra', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_reviews_description', '',array('language_id'=>0));
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);
        $messages[]='Whole catalog is updated to the default language ID.';					
    }
}

$str="select name from tx_multishop_payment_methods limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{
    $str="CREATE TABLE tx_multishop_payment_methods_description (
id int(4) NOT NULL DEFAULT '0',
language_id int(5) NOT NULL DEFAULT '1',
name varchar(255) DEFAULT NULL,
description text,
PRIMARY KEY (id,language_id),
KEY name (name),
KEY id (id),
KEY language_id (language_id),
KEY combined_two (language_id,id)
) ENGINE=MyISAM;
";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;					
    $str="select id, name from tx_multishop_payment_methods";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
    {
        $array=array();
        $array['id']=$row['id'];
        $array['name']=$row['name'];
        $array['language_id']=$this->sys_language_uid;
        $query = $GLOBALS['TYPO3_DB']->INSERTquery('tx_multishop_payment_methods_description', $array);
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);					
    }
    $str="ALTER TABLE  `tx_multishop_payment_methods` DROP  `name`";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
    
}	
$str="select name from tx_multishop_shipping_methods limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{
    $str="CREATE TABLE tx_multishop_shipping_methods_description (
id int(4) NOT NULL DEFAULT '0',
language_id int(5) NOT NULL DEFAULT '1',
name varchar(255) DEFAULT NULL,
description text,
PRIMARY KEY (id,language_id),
KEY name (name),
KEY id (id),
KEY language_id (language_id),
KEY combined_two (language_id,id)
) ENGINE=MyISAM;
";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;					
    $str="select id, name from tx_multishop_shipping_methods";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
    {
        $array=array();
        $array['id']=$row['id'];
        $array['name']=$row['name'];
        $array['language_id']=$this->sys_language_uid;
        $query = $GLOBALS['TYPO3_DB']->INSERTquery('tx_multishop_shipping_methods_description', $array);
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);					
    }
    $str="ALTER TABLE  `tx_multishop_shipping_methods` DROP  `name`";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
    
}			
$str="select customer_comments from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `customer_comments` TEXT NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}		
$str="select delivery_time from tx_multishop_products_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD  `delivery_time` varchar( 150 ) NOT NULL default ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;				
}		
$key='STORES_MODULE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Stores Module', '".$key."', '0', 'Enable multiple stores (warehouses).', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$str="select id from tx_multishop_stores limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="CREATE TABLE tx_multishop_stores (
id int(11) NOT NULL AUTO_INCREMENT,
`name` varchar(150) NOT NULL,
email varchar(150) NOT NULL,
www varchar(150) NOT NULL,
crdate int(11) NOT NULL,
address varchar(150) NOT NULL,
city varchar(60) NOT NULL,
zip varchar(15) NOT NULL,
country varchar(60) NOT NULL,
telephone varchar(20) NOT NULL,
fax varchar(20) NOT NULL,
`status` tinyint(1) NOT NULL,
lng DOUBLE NOT NULL,
lat DOUBLE NOT NULL,
INDEX (`lat`,`lng`),  
PRIMARY KEY (id),
KEY `status` (`status`)
) ENGINE=MyISAM ;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;

    $str="CREATE TABLE tx_multishop_stores_description (
id int(11) NOT NULL AUTO_INCREMENT,
language_id int(5) NOT NULL,
description text NOT NULL,
PRIMARY KEY (id,language_id),
KEY language_id (language_id)
) ENGINE=MyISAM;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
}				
$str="select sku_code from tx_multishop_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_products` ADD  `sku_code` varchar( 25 ) NOT NULL default ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
    $str="ALTER TABLE  `tx_multishop_products_flat` ADD  `sku_code` varchar( 25 ) NOT NULL default ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
    $str="ALTER TABLE  `tx_multishop_undo_products` ADD  `sku_code` varchar( 25 ) NOT NULL default ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX `sku_code` (  `sku_code` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
}			

$str="select shipping_method_label from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `shipping_method_label` varchar( 150 ) NOT NULL ,
ADD  `payment_method_label` varchar( 150 ) NOT NULL ,
ADD  `discount` decimal( 10, 4 ) NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
}			


$str="select max_usage from tx_multishop_coupons limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="ALTER TABLE  `tx_multishop_coupons` ADD  `crdate` INT( 11 ) NOT NULL ,
    ADD  `max_usage` INT( 11 ) NOT NULL DEFAULT '0',
    ADD  `discount_type` varchar( 25 ) NOT NULL DEFAULT  'percentage'
    ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
}			
$str="select id from tx_multishop_product_feeds limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{
    $str="CREATE TABLE `tx_multishop_product_feeds` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `name` varchar(75) NOT NULL,
      `page_uid` int(11) NOT NULL DEFAULT '0',
      `crdate` int(11) NOT NULL DEFAULT '0',
      `utm_source` varchar(75) NOT NULL,
      `utm_medium` varchar(75) NOT NULL,
      `utm_term` varchar(75) NOT NULL,
      `utm_content` varchar(75) NOT NULL,
      `utm_campaign` varchar(75) NOT NULL,
      `fields` text NOT NULL,
      `format` varchar(25) NOT NULL,
      `delimiter` varchar(10) NOT NULL,
      `code` varchar(150) NOT NULL,
      `status` tinyint(1) NOT NULL DEFAULT '0',
      PRIMARY KEY (`id`),
      KEY `code` (`code`)
    ) ENGINE=MyISAM;
    ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
    $messages[]=$str;
}			
$str="describe `tx_multishop_payment_transactions`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='transaction_id')
    {
        if ($row['Type']=='varchar(65)')
        {
            $str="ALTER TABLE  `tx_multishop_payment_transactions` CHANGE  `transaction_id`  `transaction_id` varchar( 150 ) NOT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}
$key='ADMIN_EDIT_ORDER_PRINT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Edit Order Print Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin edit order print page. Example value: fileadmin/scripts/admin_edit_order_print)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ADMIN_EDIT_ORDER_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Edit Order Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin edit order page. Example value: fileadmin/scripts/admin_edit_order)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ADMIN_CATEGORIES_EDIT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Categories Edit Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin categories edit page. Example value: fileadmin/scripts/admin_categories_edit)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}				
$key='ADMIN_PRODUCTS_EDIT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Products Edit Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin products edit page. Example value: fileadmin/scripts/admin_products_edit)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$key='SHOPPING_CART_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Shopping cart Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the shopping cart page. Example value: fileadmin/scripts/shopping_cart)', 11, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$indexes=array();
$table_name='tx_multishop_configuration_values';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('configuration_key',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX `configuration_key` (  `configuration_key` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX `page_uid` (  `page_uid` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration_values` ADD FULLTEXT `configuration_value` (`configuration_value`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX  `admin_search` (  `configuration_key` ,  `page_uid` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration` ADD INDEX `configuration_title` (  `configuration_title` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration` ADD FULLTEXT `configuration_value` (`configuration_value`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_configuration` ADD INDEX  `admin_search` (  `configuration_title` ,  `configuration_key` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `fe_users` ADD INDEX  `disable` (`disable`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `fe_users` ADD INDEX  `deleted` (`deleted`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `fe_users` ADD INDEX  `admin_search` (`company`,`name`,`email`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_orders` ADD INDEX `deleted` (  `deleted` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_orders` ADD INDEX `crdate` (  `crdate` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
}		
$str="select * from tx_multishop_configuration_group where id='11'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(11, 'Admin Settings', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
}			
$key='PRODUCT_EDIT_METHOD_FILTER';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product edit method filter', '".$key."', '0', 'Enables the shipping / payment methods filter on the product edit page.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$str="select hide_in_cart from tx_multishop_products_options";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_products_options` ADD  `hide_in_cart` tinyint( 1 ) NOT NULL DEFAULT '0', ADD INDEX (`hide_in_cart`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}			
$str="describe `tx_multishop_products`";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_price')
    {
        if ($row['Type']=='decimal(8,2)')
        {
            $str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_price`  `products_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
            $str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `products_price`  `products_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            $messages[]=$str;							
            
            $str="ALTER TABLE  `tx_multishop_products_attributes` CHANGE  `options_values_price`  `options_values_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;						
            $str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_new_products_price`  `specials_new_products_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
            $messages[]=$str;							
            $str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_vanaf_price`  `specials_vanaf_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
            $messages[]=$str;	
            $str="ALTER TABLE  `tx_multishop_orders_products_attributes` CHANGE  `options_values_price`  `options_values_price` decimal(10,4) DEFAULT  '0.0000'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
            $messages[]=$str;	
        }
    }
}			
$key='ULTRASEARCH';
if (isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}
$key='ULTRASEARCH_TYPE';
if (isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
    $messages[]=$str;
}			
$key='PRODUCTS_RELATIVES_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Relatives Type', '".$key."', 'default', 'The lay-out type for displaying the products relatives on the products detail page.', 7, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}						
$str="select billing_address_number from tx_multishop_orders";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `billing_address_number` varchar( 10 ) DEFAULT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}				
$str="select delivery_address_number from tx_multishop_orders";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `delivery_address_number` varchar( 10 ) DEFAULT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}				
$str="select products_id from tx_multishop_products_method_mappings";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE  `tx_multishop_products_method_mappings` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`products_id` INT( 11 ) NOT NULL DEFAULT '0',
`method_id` INT( 11 ) NOT NULL DEFAULT '0' ,
`type` varchar( 25 ) NOT NULL ,
`negate` tinyint( 1 ) NOT NULL DEFAULT '0' ,
INDEX (  `products_id` ,  `method_id` ,  `type` , `negate` )
) ENGINE = MYISAM ;
";	
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}				


$str="select sort_order from tx_multishop_products_options_values_to_products_options";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_products_options_values_to_products_options` ADD  `sort_order` INT( 11 ) NOT NULL DEFAULT '0', ADD INDEX (  `sort_order` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}			
$str="select minimum_quantity from tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_products` ADD  `minimum_quantity` INT( 11 ) NOT NULL DEFAULT '1'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_products_flat` ADD  `minimum_quantity` INT( 11 ) NOT NULL DEFAULT '1'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;						
}
$str="select maximum_quantity from tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_products` ADD  `maximum_quantity` INT( 11 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;	
    $str="ALTER TABLE  `tx_multishop_products_flat` ADD  `maximum_quantity` INT( 11 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;					
}			
$key='DB_PRICES_INCLUDE_VAT';
// not yet got the time to finish this implementation so temporary will be removed
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
/*
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Database prices are stored including VAT', '".$key."', '0', 'Enable this when you want to store the prices in the database including VAT.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;
*/				
}			
else
{
    // remove it, will be added later
    $qry = $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_configuration','configuration_key=\''.$key.'\'');				
}
$key='SEARCH_ALSO_IN_PRODUCTS_DESCRIPTION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Search also in products description', '".$key."', '0', 'This enables the search-engine to also search in the products description.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;
}			
$indexes=array();
$table_name='tx_multishop_products_to_relative_products';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('pid_to_relative_id',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `pid_to_relative_id` (  `products_id`,`relative_product_id` )	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
}			
if (!in_array('relative_to_pid_id',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `relative_to_pid_id` (  `relative_product_id`,`products_id` )	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $messages[]=$str;	
}				
$str="describe tx_multishop_products_flat";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='language_id')
    {
        if ($row['Type']=='int(5)')
        {
            $str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `language_id`  `language_id` tinyint( 2 ) NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}
$str="describe tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_model')
    {
        if ($row['Type'] !='varchar(128)')
        {
            $str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_model`  `products_model` varchar(128) NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
            $str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `products_model`  `products_model` varchar(128) NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            $messages[]=$str;	
            $str="ALTER TABLE  `tx_multishop_orders_products` CHANGE  `products_model`  `products_model` varchar(128) NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
            $messages[]=$str;	
        }
    }
}			
$str="describe tx_multishop_specials_sections";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='name')
    {
        if ($row['Type']=='varchar(15)')
        {
            $str="ALTER TABLE  `tx_multishop_specials_sections` CHANGE  `name`  `name` varchar( 30 ) NULL DEFAULT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
            $messages[]=$str;							
        }
    }
}	
$str="select file_label from tx_multishop_orders_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD `file_label` varchar( 250 ) NOT NULL DEFAULT '', ADD `file_location` varchar( 250 ) NOT NULL DEFAULT '', ADD `file_downloaded` INT(11) NOT NULL DEFAULT '0', ADD `file_download_code` varchar( 32 ) NOT NULL DEFAULT '0', ADD `file_locked` tinyint(1) NOT NULL DEFAULT '0', ADD INDEX (`file_download_code`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			

    $str="ALTER TABLE  `tx_multishop_products_description` ADD `file_label` varchar( 250 ) NOT NULL DEFAULT '', ADD `file_location` varchar( 250 ) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	


$str="select products_multiplication from tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_products` ADD  `products_multiplication` INT( 11 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;
    $str="ALTER TABLE  `tx_multishop_products_flat` ADD  `products_multiplication` INT( 11 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;				
}	

$str="select tx_multishop_discount from fe_groups";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `fe_groups` ADD  `tx_multishop_discount` INT( 2 ) NOT NULL DEFAULT '0',ADD INDEX (  `tx_multishop_discount` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$str="select code from tx_multishop_payment_transactions";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_payment_transactions` ADD `code` varchar( 35 ) NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}			
$str="select tx_multishop_discount from fe_users";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `fe_users` ADD  `tx_multishop_discount` INT( 2 ) NOT NULL DEFAULT '0',ADD INDEX (  `tx_multishop_discount` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$str="select languages_id from tx_multishop_reviews_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE  `tx_multishop_reviews_description` CHANGE  `languages_id`  `language_id` tinyint( 2 ) NOT NULL DEFAULT  '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE  `tx_multishop_reviews_description` DROP  `languages_id`";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}			

$str="select languages_id from tx_multishop_cms_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE  `tx_multishop_cms_description` CHANGE  `languages_id`  `language_id` tinyint( 2 ) NOT NULL DEFAULT  '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_cms_description` DROP  `languages_id` ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
    $messages[]=$str;																			
}			
$str="select languages_id from tx_multishop_manufacturers_cms limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE  `tx_multishop_manufacturers_cms` CHANGE  `languages_id`  `language_id` tinyint( 2 ) NOT NULL DEFAULT  '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_manufacturers_cms` DROP  `languages_id` ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
    $messages[]=$str;																			
}			
$str="select languages_id from tx_multishop_manufacturers_info limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE  `tx_multishop_manufacturers_info` CHANGE  `languages_id`  `language_id` tinyint( 2 ) NOT NULL DEFAULT  '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
    $messages[]=$str;							
    $str="ALTER TABLE  `tx_multishop_manufacturers_info` DROP  `languages_id` ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
    $messages[]=$str;							
}	
$str="describe tx_multishop_configuration_values";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='configuration_value')
    {
        if ($row['Type']=='varchar(254)')
        {
            $str="ALTER TABLE `tx_multishop_configuration_values` CHANGE  `configuration_value`  `configuration_value` TEXT DEFAULT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
        }
    }
}
$key='DISABLE_PRODUCT_ATTRIBUTES_TAB_IN_EDITOR';
$title='Disable product attributes tab in products editor';
$description='Disables the product attributes tab in the products editor';
$default_value='0';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}		
$key='SPECIALS_LISTING_TYPE';
$title='Specials Listing Type';
$description='The lay-out type for displaying the listing of the specials';
$default_value='default';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 6, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}
$str="select id from tx_multishop_payment_transactions";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE  `tx_multishop_payment_transactions` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`orders_id` INT( 11 ) NOT NULL DEFAULT '0' ,
`transaction_id` varchar( 65 ) NOT NULL ,
`psp` varchar( 25 ) NOT NULL ,
`crdate` INT( 11 ) NOT NULL DEFAULT '0' ,
`status` tinyint( 1 ) NOT NULL DEFAULT '0' ,
INDEX (  `orders_id` ,  `transaction_id` ,  `crdate` ,  `status` )
) ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$key='PRICE_FILTER_BOX_STEPPINGS';
$title='Price Filter Box Steppings';
$description='Optional field. Defines the steppings of the price filter box.';
$default_value='0-10;10-25;25-50;50-100;100-250;250-500;500-1000;1000-2000;2000-3000';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}
$key='SEND_ORDER_CONFIRMATION_LETTER_ALSO_TO';
$title='Send Order Confirmation Letters also to';
$description='Send the order confirmation letter also to the following e-mail addresses.';
$default_value='';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}				
$str="describe tx_multishop_orders";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='payed')
    {
        if (!isset($row['Default']))
        {
            $str="ALTER TABLE  `tx_multishop_orders` CHANGE  `payed`  `payed` tinyint( 1 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            $messages[]=$str;
        }
    }
}	
$str="select custom_settings from tx_multishop_categories limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_categories` ADD  `custom_settings` TEXT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;			
}		
$str="select custom_settings from tx_multishop_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_products` ADD  `custom_settings` TEXT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;							
}			
$str="select start_date from tx_multishop_specials limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_specials` ADD  `start_date` INT( 11 ) NOT NULL DEFAULT '0' AFTER  `specials_last_modified`,ADD INDEX (  `start_date` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;							
}	
$str="select contains_image from tx_multishop_products limit 1";		
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_products` ADD  `contains_image` tinyint( 1 ) NOT NULL DEFAULT '0',ADD INDEX (  `contains_image` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;							
    $str="ALTER TABLE  `tx_multishop_products_flat` ADD  `contains_image` tinyint( 1 ) NOT NULL DEFAULT '0',ADD INDEX (  `contains_image` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
    $messages[]=$str;							
}	
$key='SHOW_PRODUCTS_WITH_IMAGE_FIRST';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show products with image first', '".$key."', '0', 'If this setting is enabled the products that contains an image will be shown first.', 7, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}	
$key='CHECKOUT_ENABLE_STATE';
$title='Enable state';
$description='Show or hide the state/region inputfield.';
$default_value=0;
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}
$key='CHECKOUT_ENABLE_BIRTHDAY';
$title='Enable birthday';
$description='Show or hide the birthday inputfield.';
$default_value=0;
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;							
}			
// old updates			
$str="describe tx_multishop_products_options";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_options_id')
    {
        if ($row['Extra']!='auto_increment')
        {
            $str="ALTER TABLE  `tx_multishop_products_options` CHANGE  `products_options_id`  `products_options_id` INT( 11 ) NOT NULL AUTO_INCREMENT;";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
            $messages[]=$str;							
        }
    }
}		 			
$str="describe tx_multishop_categories";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='date_added')
    {
        if ($row['Type']=='datetime')
        {
            // date fixer
            $fields='tx_multishop_categories.date_added
            tx_multishop_categories.last_modified
            tx_multishop_configuration.last_modified
            tx_multishop_configuration.date_added
            tx_multishop_manufacturers.date_added
            tx_multishop_manufacturers.last_modified
            tx_multishop_manufacturers_info.date_last_click
            tx_multishop_modules.date
            tx_multishop_payment_methods.date
            tx_multishop_products.products_date_added
            tx_multishop_products.products_last_modified
            tx_multishop_products.products_date_available
            tx_multishop_products_flat.products_date_added
            tx_multishop_products_flat.products_date_available
            tx_multishop_reviews.date_added
            tx_multishop_reviews.last_modified
            tx_multishop_specials.specials_last_modified
            tx_multishop_specials.specials_date_added
            tx_multishop_specials.expires_date
            tx_multishop_specials.date_status_change
            tx_multishop_undo_products.products_last_modified
            tx_multishop_undo_products.products_date_added
            tx_multishop_undo_products.products_date_available
            tx_multishop_coupons.startdate
            tx_multishop_coupons.enddate			
            tx_multishop_shipping_methods.date
            tx_multishop_shipping_options.date
            tx_multishop_specials_sections.date
            ';
            $array=explode("\n",$fields);
            $output=array();			
            foreach ($array as $item)
            {
                $item=trim($item);
                $var=explode(".",$item);
                if ($var[0] and $var[1])
                {
                    $str="ALTER TABLE  `".$var[0]."` CHANGE  `".$var[1]."`  `".$var[1]."` INT( 11 ) DEFAULT 0;";
                    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
                    $messages[]=$str;															
                }
            }
            break;
            // date fixer eof
        }
    }
}
$str="describe tx_multishop_products_options_values";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_options_values_id')
    {
        if ($row['Extra']!='auto_increment')
        {
            $str="ALTER TABLE  `tx_multishop_products_options_values` CHANGE  `products_options_values_id`  `products_options_values_id` INT( 11 ) NOT NULL AUTO_INCREMENT;";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
            $messages[]=$str;																					
        }
    }
}
$str="describe tx_multishop_products_options_values_to_products_options";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($row['Field']=='products_options_values_to_products_options_id')
    {
        if ($row['Extra']!='auto_increment')
        {
            $str="ALTER TABLE `tx_multishop_products_options_values_to_products_options` CHANGE `products_options_values_to_products_options_id` `products_options_values_to_products_options_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
            $messages[]=$str;																					
        }
    }
}			
$str="select id from tx_multishop_orphan_files limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE `tx_multishop_orphan_files` (
    `id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
    `type` varchar( 50 ) NOT NULL ,
    `path` TEXT NOT NULL ,
    `file` varchar(255) NOT NULL ,
    `orphan` tinyint(1) NOT NULL DEFAULT '0',
    `checked` tinyint(1) NOT NULL DEFAULT '0',
    `crdate` INT( 11 ) NOT NULL  DEFAULT '0',
    INDEX ( `type` ),
    INDEX ( `crdate`),
    INDEX ( `file`),
    INDEX ( `orphan`),
    INDEX ( `checked`),
    FULLTEXT (`path`)
    ) ENGINE = MYISAM ;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$str="select categories_url from tx_multishop_categories limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_categories` ADD  `categories_url` varchar( 254 ) NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$str="select content_footer from tx_multishop_categories_description limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_categories_description` ADD  `content_footer` TEXT NOT NULL AFTER  `content`";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}				
$str="select invoice_id from tx_multishop_invoices limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE `tx_multishop_invoices` (
    `id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
    `invoice_id` varchar(255) NOT NULL ,
    `invoice_inc` varchar(11) NOT NULL ,
    `orders_id` INT( 11 ) NOT NULL DEFAULT '0' ,
    `date` INT( 11 ) NOT NULL DEFAULT '0' ,
    `status` INT( 11 ) NOT NULL  DEFAULT '0'
    ) ENGINE = MYISAM ;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}					

$str="select id from tx_multishop_specials_sections limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE  `tx_multishop_specials_sections` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`specials_id` INT( 11 ) NOT NULL DEFAULT '0' ,
`date` int(11) NOT NULL DEFAULT '0',
`name` varchar( 30 ) NOT NULL
)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_specials_sections` ADD INDEX (  `date` ), ADD INDEX (  `specials_id` ), ADD INDEX (  `name` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}		
$str="select status from tx_multishop_specials_sections limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_specials_sections` ADD  `status` tinyint( 1 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_specials_sections` ADD INDEX (  `status` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
    $str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_id`  `specials_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $messages[]=$str;																			
}	
$key='FLAT_DATABASE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Flat Database', '".$key."', '0', 'This module creates flat products and categories database tables for maximum speed. An essential module for webshops that contain more than 250.000 products.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;																			
}
$key='FLAT_DATABASE_EXTRA_ATTRIBUTE_OPTION_COLUMNS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Flat Database extra attribute option columns', '".$key."', '', 'If you use the flat database module and you need the (single) attribute values inside a seperate table field in the flat table then define the attribute option id\'s here (example: 1:varchar(10);4:int(10);5:varchar(10);10:varchar(10)).', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $messages[]=$str;																			
}		
$key='AFFILIATE_SHOP';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $str="delete from `tx_multishop_configuration` where configuration_title='iDEAL Test Stage';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    $str="replace INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(3, 'Misc', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Affiliate Shop', '".$key."', '0', 'This module enables the webshop as affiliate shop (hiding the order/basket system).', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='CACHE_FRONT_END';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache front-end', '".$key."', '0', 'This module enables optimal caching features to the front-end. It will boost performance to big stores.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCTS_SHORT_DESCRIPTION_CONTAINS_HTML_MARKUP';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products short description contains HTML markup', '".$key."', '0', 'Defines whether we should save the content as plain text or by HTML markup.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$key='CACHE_TIME_OUT_LISTING_PAGES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for categories/products listing page', '".$key."', '3600', 'Specify the expiry time of the categories and products listing page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$key='CACHE_TIME_OUT_SEARCH_PAGES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for search page', '".$key."', '3600', 'Specify the expiry time of the search page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$key='CACHE_TIME_OUT_PRODUCTS_DETAIL_PAGES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for products detail page', '".$key."', '3600', 'Specify the expiry time of the products detail page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}		
$key='CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for the categories navigation menu', '".$key."', '3600', 'Specify the expiry time of the categories navigation menu cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}		
$key='COUNTRY_ISO_NR';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Webshop Country ISO Number', '".$key."', '0', 'The country where the webstore is located. Used to determine the local VAT classes.', 3, NULL, NULL, now(), NULL, 'tep_country_select_option(');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
$key='SHOW_INNER_FOOTER_NAV';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show the footer navigation in the middle content', '".$key."', '0', 'This module enables the inner footer navigation.', 1, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='STORE_NAME';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store Name', '".$key."', '', 'The name of the store.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='STORE_EMAIL';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store E-mail', '".$key."', '', 'The e-mail address of the store owner.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
// update fixed

$str="select `prefix_source_name` from tx_multishop_import_jobs limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_import_jobs` ADD `prefix_source_name` varchar( 50 ) NOT NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_import_jobs` ADD INDEX ( `prefix_source_name` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select `products_model` from tx_multishop_orders_products limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD  `products_model` varchar( 64 ) NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}	
$str="select `deleted` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_orders` ADD  `deleted` tinyint( 1 ) DEFAULT 0";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}				
$str="select `key` from tx_multishop_configuration ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_configuration` CHANGE `key` `configuration_key` varchar( 64 ) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select `depend_on_configuration_key` from tx_multishop_configuration limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE  `tx_multishop_configuration` ADD  `depend_on_configuration_key` varchar( 64 ) NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}	
$str="select `code` from tx_multishop_import_jobs limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_import_jobs` ADD `code` varchar( 16 ) NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_import_jobs` ADD INDEX ( `code` ) ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="SELECT * from tx_multishop_import_jobs order by id desc";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    while (($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
    {			
        // fix the registered jobs that hasnt got any md5 code
        $updateArray=array();
        $updateArray['code']					=md5(uniqid());		
        $query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_import_jobs', 'id=\''.$row['id'].'\'',$updateArray);
        $res = $GLOBALS['TYPO3_DB']->sql_query($query);	
    }
}

$str="select `value` from tx_multishop_configuration ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_configuration` CHANGE `value` `configuration_value` varchar( 64 ) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select `title` from tx_multishop_configuration ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_configuration` CHANGE `title` `configuration_title` varchar( 64 ) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select `title` from tx_multishop_configuration_group ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_configuration_group` CHANGE `title` `configuration_title` varchar( 64 ) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}	
$str="select products_tax_class_id from tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_products` CHANGE `products_tax_class_id` `tax_id` INT( 5 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select page_id from tx_multishop_cms";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_cms` CHANGE `page_id` `page_uid` INT(11) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select date_added from tx_multishop_cms";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_cms` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select date_added from tx_multishop_orders_status_history";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_orders_status_history` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select payed from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `payed` tinyint( 1 ) NOT NULL DEFAULT '0' ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_orders` ADD INDEX ( `payed` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select by_phone from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `by_phone` tinyint( 1 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_orders` ADD INDEX ( `by_phone` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}

$str="select option_attributes from tx_multishop_categories limit 1";
 $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
 if (!$qry)
 { 
  $str="ALTER TABLE `tx_multishop_categories` ADD `option_attributes` varchar( 254 ) NOT NULL  DEFAULT ''";
  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
 }
 
$str="select * from tx_multishop_shipping_countries limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE `tx_multishop_shipping_countries` (
  `id` int(11) NOT NULL auto_increment,
  `page_uid` int(11) NOT NULL DEFAULT '0',
  `cn_iso_nr` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `cn_iso_nr` (`cn_iso_nr`,`page_uid`)
) ENGINE=MyISAM  ;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select id from tx_multishop_coupons limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="CREATE TABLE IF NOT EXISTS `tx_multishop_coupons` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`code` varchar(250) DEFAULT '',
`discount` decimal(5,2) NOT NULL DEFAULT '0.00',
`status` tinyint(1) NOT NULL DEFAULT '0',
`startdate` date NOT NULL,
`enddate` date NOT NULL,
`times_used` int(5) NOT NULL DEFAULT '0',
PRIMARY KEY (`id`),
UNIQUE KEY `code` (`code`)
) ENGINE=MyISAM ;
";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select endate from tx_multishop_coupons";		
if (($qry=$GLOBALS['TYPO3_DB']->sql_query($str)) != false)
{
    $str="ALTER TABLE `tx_multishop_coupons` CHANGE `endate` `enddate` DATE NOT NULL";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_coupons` CHANGE `status` `status` tinyint( 1 ) NOT NULL DEFAULT '0'";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_coupons` ADD `times_used` INT( 5 ) NOT NULL DEFAULT '0' ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $str="ALTER TABLE `tx_multishop_coupons` ADD UNIQUE (`code` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select * from tx_multishop_configuration_group where id='2'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
{
    $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
    if ($row['configuration_title']=='Product Listing')
    {
        $str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }	
    elseif ($row['configuration_title']=='Image Size Settings')
    {
        $str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }			
}	
$str="select * from tx_multishop_configuration_group where id='3'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
{
    $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
    if ($row['configuration_title']=='Misc')
    {
        $str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Webshop Settings' WHERE `id` =3;";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }	
}		
$str="select * from tx_multishop_configuration where configuration_title='Store Name' and group_id='1'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
{
    $str="UPDATE `tx_multishop_configuration` SET `group_id` =3 WHERE configuration_title='Store Name';";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
// 12 july 2010
$str="select `billing_phone` from tx_multishop_orders ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` CHANGE `billing_phone` `billing_telephone` varchar( 150 ) NULL DEFAULT NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}	
$str="select `delivery_phone` from tx_multishop_orders ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` CHANGE `delivery_phone` `delivery_telephone` varchar( 150 ) NULL DEFAULT NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
$str="select `billing_gender` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `billing_gender` CHAR( 1 ) NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
$str="select `billing_birthday` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `billing_birthday` int( 11 ) NULL DEFAULT '0' ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
$str="select `billing_email` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `billing_email` varchar( 254 ) NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
$str="select `delivery_gender` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `delivery_gender` CHAR( 1 ) NULL ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
$str="select `delivery_email` from tx_multishop_orders limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
    $str="ALTER TABLE `tx_multishop_orders` ADD `delivery_email` varchar( 254 ) NULL 	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$key='CATEGORIES_LISTING_SPECIALS_CATEGORIES_SUBLEVEL';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show specials box till categories sublevel', '".$key."', '2', 'This value defines till which categories sublevel the specials scroller should be shown. Choose 0 to show the specials on each categories level.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			


$key='SHOW_PRICES_INCLUDING_VAT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show prices including VAT', '".$key."', '1', 'This setting defines whether we should show product prices including VAT or without.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$key='MANUAL_ORDER';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Enable the manual order', '".$key."', '0', 'This module enables the manual order.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

$key='INVOICE_PRINT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'This module enable to print invoice order', '".$key."', '0', 'This module enable to print invoice order.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

$key='PACKING_LIST_PRINT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'This module enable to print order packing list', '".$key."', '0', 'This module enable to print order packing list.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

$key='INVOICE_PREFIX';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Invoice prefix', '".$key."', '0', 'Invoice prefix.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='ACCORDION_MENU';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Accordion Menu', '".$key."', '0', 'Accordion menu.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='ACCORDION_SETUP_MODULES';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Accordion Setup Modules', '".$key."', '0', 'Accordion for setup modules.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

// 12 july eof	
//13 oct 2010 for fe_user
$str="select address_number from fe_users limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
$str="ALTER TABLE `fe_users` ADD `address_number` varchar( 150 ) NULL DEFAULT NULL";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select mobile from fe_user limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
$str="ALTER TABLE `fe_users` ADD `mobile` varchar( 150 ) NULL DEFAULT NULL";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$str="select attribute_image from tx_multishop_products_attributes limit 1";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$qry)
{	
$str="ALTER TABLE `tx_multishop_products_attributes` ADD `attribute_image` varchar( 150 ) NULL DEFAULT NULL";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}

$width='normal';
$value="176x140";
$key='CATEGORY_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category image size', '".$key."', '".$value."', 'The maximum image size in pixels for the category image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		

}
$width=50;
$value="50x50";
$key='PRODUCT_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$width=100;
$value="175x123";
$key='PRODUCT_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$width=200;
$value="140x150";
$key='PRODUCT_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$width=300;
$value="350x300";
$key='PRODUCT_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$width='enlarged';
$value="600x400";
$key='PRODUCT_IMAGE_SIZE_'.t3lib_div::strtoupper($width);
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

// meta
$key='META_TITLE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Title', '".$key."', 'Webshop Title', 'The title of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='META_DESCRIPTION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Description', '".$key."', 'Description of the webshop.', 'The description of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='META_KEYWORDS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Keywords', '".$key."', 'keyword1, keyword2', 'The search words that are related to the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$str="select * from tx_multishop_configuration_group where id='4'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(4, 'Webshop Plugins', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$str="select * from tx_multishop_configuration_group where id='8'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(8, 'Checkout Settings', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
    $key='CHECKOUT_LENGTH_TELEPHONE_NUMBER';
    if (!isset($settings['GLOBAL_MODULES'][$key]))
    {
        $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Length telephone number', '".$key."', '10', 'The total chars of a valid telephone number.', 8, NULL, NULL, now(), NULL, '');";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }	
    $key='CHECKOUT_VALIDATE_FORM';
    if (!isset($settings['GLOBAL_MODULES'][$key]))
    {
        $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Validate Checkout Form', '".$key."', '1', 'Validate Checkout Form by JavaScript.', 8, NULL, NULL, now(), NULL, '');";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }					
    $key='CHECKOUT_REQUIRED_TELEPHONE';
    $title='Telephone Required';
    $description='Validate Checkout Form by JavaScript.';
    $default_value=1;
    if (!isset($settings['GLOBAL_MODULES'][$key]))
    {
        $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, '');";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
    }						
}		
$str="select * from tx_multishop_configuration_group where id='9'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(9, 'Orders Settings', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
}
$key='ORDERS_CUSTOM_EXPORT_SCRIPT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Orders Custom Export Script', '".$key."', '', 'Optionally you can process the newly created orders by your custom script.', 9, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}				
$key='ORDERS_PAYED_CUSTOM_SCRIPT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Orders Payed Custom Script', '".$key."', '', 'Optionally you can process the payed order by your custom script.', 9, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}				
$str="select * from tx_multishop_configuration_group where id='10'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(10, 'Products Stock Settings', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
}

$key='SHOW_STOCK_LEVEL_AS_BOOLEAN';	
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show stock level as boolean (yes/no)', '".$key."', '0', 'Instead of showing the total count of the products stock level, show stock as: yes or no.', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''yes_without_image'',''yes_with_image'', ''no''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$key='GOOGLE_ANALYTICS_ACCOUNT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Analytics Account', '".$key."', 'UA-16775241-1', 'Google Analytics is the enterprise-class web analytics solution that gives you rich insights into your website traffic and marketing effectiveness.', 4, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='ADDTHIS_ACCOUNT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Addthis Account', '".$key."', 'typo3multishop', 'Add a Addthis button to your webshop. Addthis.com makes sharing your website urls easy.', 4, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='GOOGLE_ADWORDS_CONVERSION_CODE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Adwords Conversion Code', '".$key."', '', 'Add a Google Adwords Conversion Code to the thank you page of the webshop. This makes it possible to calculate the success-ratio of your Google Adwords campaign.', 4, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCT_IMAGE_WATERMARK_TEXT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Text', '".$key."', '', 'Add a watermark to enlarged product images. Example value: typo3multishop.com', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$key='PRODUCT_IMAGE_WATERMARK_WIDTH';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Width', '".$key."', '100', 'The width of the text. Example value: 100', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$key='PRODUCT_IMAGE_WATERMARK_HEIGHT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Height', '".$key."', '60', 'The height of the text. Example value: 60', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}				
$key='PRODUCT_IMAGE_WATERMARK_FONT_SIZE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Font-size', '".$key."', '16', 'Specify the font-size (in pt) of the watermark. Example value: 16', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCT_IMAGE_WATERMARK_FONT_FILE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Font File', '".$key."', 'nasaliza.ttf', 'Specify the font file for the watermarking. Example value: nasaliza.ttf', 2, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$key='PRODUCT_IMAGE_WATERMARK_POSITION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Position', '".$key."', 'south-east', 'Choose the position of the watermark.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''north-east'', ''south-east'',''south-west'',''north-west''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$key='PRODUCT_IMAGE_SHAPED_CORNERS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every thumbnailed product image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}	
$key='CATEGORY_IMAGE_SHAPED_CORNERS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every category image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}		
// ok now we going to convert the table schemes
// products description
$from	='products_title_seo';
$to	='products_meta_title';
$str="select ".$from." from tx_multishop_products_description";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$from	='meta_description';
$to	='products_meta_description';
$str="select ".$from." from tx_multishop_products_description";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$from	='products_keywords';
$to	='products_meta_keywords';
$str="select ".$from." from tx_multishop_products_description";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if ($qry)
{	
    $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$key='PRODUCTS_LISTING_LIMIT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Limiting', '".$key."', '18', 'The total number of displayed products per page.', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='CHECKOUT_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Checkout Type', '".$key."', 'multistep', 'Choose which checkout process should be used (ie: multistep).', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='SHOW_PRICES_WITH_AND_WITHOUT_VAT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show product prices with and without VAT', '".$key."', '0', 'If products contain VAT the price including and excluding VAT will be shown.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$str="select * from tx_multishop_configuration_group where id='5'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(5, 'Categories Listing', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$str="select * from tx_multishop_configuration_group where id='6'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(6, 'Products Listing', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='CATEGORIES_LISTING_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Categories Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the categories listing.', 5, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCTS_LISTING_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the products listing.', 6, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCTS_LISTING_AUTOCORRECTION_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Autocorrection Type', '".$key."', 'default', 'The lay-out type for displaying the products listing in the autocorrection module.', 6, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$str="select * from tx_multishop_configuration_group where id='7'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(7, 'Products Detail Page', '', NULL, 1);";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCTS_DETAIL_PAGE_PAGINATION';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Pagination', '".$key."', '0', 'Show\'s a button Previous and Next on the products detail page to go to the next or previous product within the same category.', 7, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$key='PRODUCTS_DETAIL_TYPE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
 {
  $str="INSERT INTO `tx_multishop_configuration` (`configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('Products Detail Type', 'PRODUCTS_DETAIL_TYPE', 'default', 'The lay-out type for displaying the products detail page.', 7, NULL, NULL, now(), NULL, '');";
  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);  
 }
 
$key='STAFFEL_PRICE_MODULE';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
  $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Staffel Prices', '".$key."', '0', 'Enable staffel prices to your webshop.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
}
$key='ULTRASEARCH_FIELDS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Ultrasearch Fields', '".$key."', '', 'Define which fields you\'d like to show in the ultrasearch form. (example: 1:list;2:radio;3:checkbox;price_filter:0-1000)', 3, NULL, NULL, now(), NULL, '');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}			
$key='COUPONS';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Coupon Code', '".$key."', '0', 'Activate coupon code.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}

$key='ORDER_EDIT';
if (!isset($settings['GLOBAL_MODULES'][$key]))
{
    $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Order Edit', '".$key."', '0', 'Enables you to edit orders.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}
$sql = "describe tx_multishop_shipping_countries_to_zones";
$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($rs['Field'] == 'cn_iso_nr') 
    {
        if ($rs['Type'] =='int(4)')
        {
            $str="ALTER TABLE `tx_multishop_shipping_countries_to_zones` CHANGE `cn_iso_nr` `cn_iso_nr` INT( 11 ) NULL DEFAULT NULL";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            break;
        }
    }
}
$sql = "describe tx_multishop_products_description";
$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $colname='products_shortdescription';
    if ($rs['Field'] == $colname) 
    {
        if ($rs['Type'] =='text')
        {
            $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` varchar(255) NULL DEFAULT ''";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            break;
        }
    }
    $colname='products_negative_keywords';
    if ($rs['Field'] == $colname) 
    {
        if ($rs['Type'] =='text')
        {
            $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` varchar(255) NULL DEFAULT ''";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            break;
        }
    }
    $colname='promotext';
    if ($rs['Field'] == $colname) 
    {
        if ($rs['Type'] =='text')
        {
            $str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` varchar(255) NULL DEFAULT ''";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            break;
        }
    }				
}
$sql = "describe tx_multishop_orders";
$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($rs['Field'] == 'crdate') 
    {
        if ($rs['Type'] =='date')
        {
            $str="ALTER TABLE `tx_multishop_orders` CHANGE `crdate` `crdate` INT( 11 ) NOT NULL DEFAULT '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            break;
        }
    }
}	
$str="SELECT * from tx_multishop_import_jobs limit 1";
if (!$qry=$GLOBALS['TYPO3_DB']->sql_query($str))
{	
    $str="CREATE TABLE `tx_multishop_import_jobs` (
    `id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
    `name` varchar( 254 ) NOT NULL ,
    `period` INT( 11 ) NOT NULL DEFAULT '0' ,
    `last_run` INT( 11 ) NOT NULL DEFAULT '0' ,
    `data` TEXT NOT NULL ,
    `status` tinyint( 1 ) NOT NULL DEFAULT '0' ,
    `page_uid` INT( 11 ) NOT NULL DEFAULT '0',
    `categories_id` INT( 5 ) NOT NULL DEFAULT '0',
    INDEX ( `last_run` , `status` , `page_uid`,`categories_id` ) 
    ) ;";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
}	
$str="describe tx_multishop_products";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    if ($rs['Field']=='products_id')
    {
        if ($rs['Type'] =='int(5)')
        {
            $str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            $str="ALTER TABLE  `tx_multishop_products_description` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            
            $str="ALTER TABLE  `tx_multishop_products_attributes` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            $str="ALTER TABLE  `products_attributes_id` CHANGE  `products_attributes_id`  `products_attributes_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            $str="ALTER TABLE  `tx_multishop_products_attributes_extra` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            $str="ALTER TABLE  `tx_multishop_products_options` CHANGE  `products_options_id`  `products_options_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            $str="ALTER TABLE  `tx_multishop_products_options_values` CHANGE  `products_options_values_id`  `products_options_values_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
            
            $str="ALTER TABLE  `tx_multishop_products_options_values_extra` CHANGE  `products_options_values_extra_id`  `products_options_values_extra_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
            
            $str="ALTER TABLE  `tx_multishop_products_options_values_to_products_options` CHANGE  `products_options_values_to_products_options_id`  `products_options_values_to_products_options_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
            $str="ALTER TABLE  `tx_multishop_products_to_categories` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);										
            $str="ALTER TABLE  `tx_multishop_products_to_relative_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            $str="ALTER TABLE  `tx_multishop_products_to_relative_products` CHANGE  `relative_product_id`  `relative_product_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            $str="ALTER TABLE  `tx_multishop_reviews` CHANGE  `reviews_id`  `reviews_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            $str="ALTER TABLE  `tx_multishop_reviews` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            $str="ALTER TABLE  `tx_multishop_reviews_description` CHANGE  `reviews_id`  `reviews_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            $str="ALTER TABLE  `tx_multishop_specials` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
            $str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_id`  `specials_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);	

            $str="ALTER TABLE  `tx_multishop_undo_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
            $qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
            break;
        }
    }
}		

$indexes=array();
$table_name='tx_multishop_products';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
for ($i=0;$i<5;$i++)
{
    $index=$i;
    if ($index==0) $index='';
    if (!in_array('products_image'.$index,$indexes))
    {
        $str="ALTER TABLE `".$table_name."` ADD INDEX `products_image".$index."` (`products_image".$index."`)";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    }					
}						
// add combined indexes for maxium speed
$indexes=array();
$table_name='tx_multishop_products_options';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}			
if (!in_array('products_options_name',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `products_options_name` (  `language_id`,`products_options_name` )	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
// add full text index to products_model for maxium speed
$indexes=array();
$table_name='tx_multishop_products_description';
$str="show indexes from `".$table_name."` where Index_type='FULLTEXT' and Key_name ='products_model_2'";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
{
    $str="ALTER TABLE  `".$table_name."` ADD FULLTEXT `products_model_2` (`products_model` )	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
}
$indexes=array();
$table_name='tx_multishop_products_options_values';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('products_options_values_name',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `products_options_values_name` (  `products_options_values_name` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
// delete double keys
$indexes=array();
$table_name='tx_multishop_coupons';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (in_array('code_10',$indexes))
{
    for ($i=2;$i<65;$i++)
    {
        $str="ALTER TABLE  `tx_multishop_coupons` DROP INDEX  `code_".$i."`";
        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    }
    $str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `status` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `startdate` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `enddate` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `times_used` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `orders_id` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `status` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `invoice_id` ) ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `date` ) ";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_orders_products` ADD INDEX (  `products_name` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD INDEX (  `orders_id` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD INDEX (  `orders_products_id` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
    $str="ALTER TABLE  `tx_multishop_orders_status_history` ADD INDEX (  `crdate` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			


}
// delete double keys eof
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `combined_one` (`language_id`,`products_options_values_name` )";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
$indexes=array();
$table_name='tx_multishop_categories';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `".$table_name."` ADD INDEX `combined_one` (`page_uid`,`status`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_two',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_categories` ADD INDEX  `combined_two` (`page_uid`,`status`,`categories_id`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_three',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_categories` ADD INDEX  `combined_three` (`page_uid`,`status`,`parent_id`)	";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
$indexes=array();
$table_name='tx_multishop_categories_description';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_one` (  `language_id`,`categories_name`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_two',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_two` (  `language_id`,`categories_id`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_three',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_three` (  `language_id`,`categories_id`,`categories_name`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
$indexes=array();
$table_name='tx_multishop_products';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_one` (`page_uid`,`products_status`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_two',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_two` (`page_uid`,`products_status`,`products_id`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_three',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_three` (`page_uid`,`products_status`,`sort_order`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
if (!in_array('combined_four',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_four` (`page_uid`,`products_status`,`products_model`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_five',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_five` (`page_uid`,`products_status`,`products_date_added`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_six',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_six` (`page_uid`,`products_status`,`products_last_modified`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
if (!in_array('combined_seven',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_seven` (`page_uid`,`products_status`,`products_date_available`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_eight',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_eight` (`page_uid`,`products_status`,`extid`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_nine',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_nine` (`page_uid`,`products_status`,`products_price`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
$indexes=array();
$table_name='tx_multishop_products_description';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_one` (  `language_id`,`products_name`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_two',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_two` (  `language_id`,`products_id`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_three',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_three` (  `language_id`,`products_id`,`products_name`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
if (!in_array('combined_seven',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_seven` (  `language_id`,`products_meta_keywords`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_eight',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_eight` (  `language_id`,`products_name`,`products_description`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}				
$indexes=array();
$table_name='tx_multishop_specials';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_one',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_one` (`page_uid`,`status`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_two',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_two` (`page_uid`,`status`,`specials_new_products_price`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}	
if (!in_array('combined_three',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_three` (`page_uid`,`status`,`expires_date`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
if (!in_array('combined_four',$indexes))
{
    $str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_four` (`page_uid`,`status`,`expires_date`,`specials_new_products_price`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}
$indexes=array();
$table_name='tx_multishop_products_description';
$str="show indexes from `".$table_name."` ";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
while (($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry)) != false)
{
    $indexes[]=$rs['Key_name'];
}
if (!in_array('combined_four',$indexes))
{
    $str="ALTER TABLE `tx_multishop_products_description` ADD FULLTEXT  `combined_four` (`products_name` ,`products_description`)";
    $qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
}				
// end combined indexes
// delete duplicates
$str="ALTER IGNORE TABLE tx_multishop_configuration ADD UNIQUE INDEX dupidx (configuration_key);";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
$str="ALTER TABLE tx_multishop_configuration DROP INDEX dupidx;";
$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
?>