<?php
require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/checkoutfi.php');

$co = new CheckoutFI($vars['merchant_id'],$vars['security_key']); // merchantID and securitykey (normally about 80 chars)

if(isset($_GET['MAC'])) {
	if($co->validateCheckout($_GET)) {
		$transaction_id = $_GET['REFERENCE'];
		$orders_id=mslib_fe::getOrdersIdByTransactionId($transaction_id,'checkout');
		if ($orders_id)
		{
			if($co->isPaid()) {
				mslib_fe::updateOrderStatusToPayed($orders_id);
				header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));
				exit();
			} else {
				header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_declineurl'));
				exit();
			}
		}
		
	} else {
		header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_declineurl'));
		exit();
	}
	
} else {
	$amount=(preg_replace("/^0/",'',round($order['total_amount'],2))*100);
	$transaction_id=mslib_fe::createPaymentTransactionId($order['orders_id'],'checkout',$order['payment_method'], 'crc32');
	
	// Order information
	$coData=array();
	$coData["stamp"] 			=$order['orders_id']; // unique timestamp
	$coData["reference"] 		=$transaction_id;
	$coData["message"] 			= 'shopping at '.htmlspecialchars($ms['MODULES']['STORE_NAME']).' - '.$order['orders_id'];
	$coData["return"] 			= substr($this->FULL_HTTP_URL, 0, strlen($this->FULL_HTTP_URL) - 1).$_SERVER['REQUEST_URI'];
	$coData["amount"] 			= str_replace('.','',$amount); // price in cents
	$coData["delivery_date"] 	= date("Ymd");
	$coData["firstname"] 		= $order['billing_first_name']. ' ' . $order['billing_middle_name'];
	$coData["familyname"] 		= $order['billing_last_name'];
	$coData["address"] 			= $order['billing_address'];
	$coData["postcode"] 		= $order['billing_zip'];
	$coData["postoffice"] 		= $order['billing_city'];
	$coData["email"] 			= $order['billing_email'];
	$coData["cancel"] 			= $this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl');
	$coData["reject"] 			= $this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_declineurl');
	
	// XML mode with bank buttons
	$return=$co->getCheckoutXML($coData); // get payment button data
	$xml=simplexml_load_string($return);
	$link=$xml->paymentURL;
	
	foreach($xml->payments->payment->banks as $bankX) {
		foreach($bankX as $bank) {
	  		$content .= '<div class="C1">';
	   		$content .= '<form action='.$bank['url'].' method="post">';
	   		
	   		foreach($bank as $key => $value) {
	     		$content .= '<input type="hidden" name="'.$key.'" value="'.$value.'" />';
	   		}
	   		
	    	$content .= '<span><input type="image" src="'.$bank['icon'].'" /></span>';
	    	$content .= '<div>'.$bank['name'].'</div>';
	   		
	   		$content .= '</form>';
	  		$content .= '</div>';
		}
	}
}
?>
