<?php
/*
MBE4.DE IMPLEMENTATION	
-------------------------------------
*/

$mbe4url="https://billing.mbe4.de/widget/singlepayment";
$username 		= $vars['username'];  						// Username eintragen
$clientid 		= $vars['client_id'];						// ClientId eintragen
$serviceid 		= $vars['service_id'];						// ServiceId eintragen
$contentclass 	= $vars['content_class'];					// eine Contentclass eintragen
$mbe4password 	= $vars['password']; 					// mbe4 Password eintragen

if ($_GET['clienttransactionid']) {
	$transactionid 			= $_GET["transactionid"];
	$clienttransactionid 	= $_GET["clienttransactionid"];
	$responsecode 			= $_GET["responsecode"];
	$description 			= $_GET["description"];
	$subscriberid 			= $_GET["subscriberid"];
	$operatorid 			= $_GET["operatorid"];
	$timestamp 				= $_GET["timestamp"];
	$hashparam 				= $_GET["hash"];
	
	// check hash Signierung
	$hashbase=$mbe4password.$transactionid.$clienttransactionid.$responsecode.$description.$subscriberid.$operatorid.$timestamp;
	
	if(md5($hashbase)!=$hashparam) {
		echo "<p>Parameter nicht korrekt oder manipuliert!</p>";
	}
	
	
	if($responsecode=='0') 	{
		$clienttransactionid = str_replace('test-', '', $clienttransactionid);
		$orders_id=mslib_fe::getOrdersIdByTransactionId($clienttransactionid,'mbe4');
		if ($orders_id)
		{
			mslib_fe::updateOrderStatusToPayed($orders_id);
			header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));
			exit();
		}
		
	} else {
		header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl'));
	}
	
} else {
	$description 	= utf8_encode('shop at http://' . $_SERVER['HTTP_HOST']);		// Beschreibung des Artikels eintragen
	
	
	$transaction_id = mslib_fe::createPaymentTransactionId($order['orders_id'],'mbe4',$order['payment_method'], 'short_md5');
	$clienttransactionid 	= "test-".$transaction_id;
	
	$amount 		= (preg_replace("/^0/",'',$order['total_amount']));
	$amount 		= $amount*100; 								// Betrag in ct z.B: 19
	
	$callbackurl 	= substr($this->FULL_HTTP_URL, 0, strlen($this->FULL_HTTP_URL) - 1).$_SERVER['REQUEST_URI']; 						// RuecksprungURL eintragen z.B. https://www.ihrwebshop.com/result.php
	$timestamp 		= date("Y-m-d")."T".date("H:i:s.000")."Z";
	
	$hashbase 		= $mbe4password.$username.$clientid.$serviceid.$contentclass.$description.$clienttransactionid.$amount.$callbackurl.$timestamp;
	
	// hash erzeugen
	$hashparam=md5($hashbase);
	
	
	$params="";
	$params.="username=".urlencode($username);
	$params.="&clientid=".urlencode($clientid);
	$params.="&serviceid=".urlencode($serviceid);
	$params.="&contentclass=".urlencode($contentclass);
	$params.="&description=".urlencode($description);
	$params.="&clienttransactionid=".urlencode($clienttransactionid);
	$params.="&amount=".urlencode($amount);
	$params.="&callbackurl=".urlencode($callbackurl);
	$params.="&timestamp=".urlencode($timestamp);
	$params.="&hash=".$hashparam;

	
	$content.='mbe4 payment widget Testkauf: ';
	$content.='<a href="'.$mbe4url.'?'.$params.'" >kaufen->></a>';
}
?>